/******************************************************************************

  Messung von IR Pulsen - Puls/Pause Verhltnis
  MEGA8, 11.0592 MHz
  FB Traegerfrequenz = 36kHz, Periode = 28us

  Funktion:
  
  16 Bit Timer wird initalisiert & zur Zeitmessung verwendet.
  Ein Timerberlauf whrend der Eingang '1' ist fhrt zum Ende.
  Der Timer wird im externen Interrupt gesetzt / gelesen. 
  Wenn ein Ende erkannt wurde, so werden die Stnde ausgegeben.
  Ein Tick dauert ~723ns

  Durch die Buffersize wird die Anzahl Pulse pro Telegram hier auf
  63 begrenzt. 

******************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#include <stdlib.h>
#include <inttypes.h>

#include "irsample.h"
#include "serial.h"
#include "toa.h"



/******************************************************************************
  
  Ausgabe der Pulse/Pausenzeiten. Die erste Zahl ist die Laenge der ersten 
  Pause. Einheit: ~723ns

******************************************************************************/
void print_us(unsigned short us)
{
  char buffer[8];
  u16toa (us, buffer, 10);
  sputs (buffer);
}

void PrintIRData(void)
{
  int i;
  sputs ("Ticks:");
  for (i = 0; i < ir_index; i++) {    
    print_us(ir_ticks[i]);
    sputs (" ");
  } 
  sputs ("\r\n");
}


/******************************************************************************

  Main

******************************************************************************/
int main(void)
{
  inituart();

  sputs ("IR Analyzer V1.3  25.09.2003");

  ir_init();
 
  sei();                              // enable interrupts

	while(1) {
    if (ir_ready) {
      PrintIRData();
      // -> DecodeData();
      ir_init();        
    }
  }
}


