#include "toa.h"

//
// konvertiert unsigned 16Bit Wert in String
//
void u16toa(unsigned short value, char *buf, unsigned char radix)
{
  char *pbuf = buf;
  unsigned char modulo;
  char temp;
  
  do {
    modulo = value % radix;
    value /= radix;
    if (modulo > 9) {
      *pbuf = modulo + 'a' - 10;
    } else {
      *pbuf = modulo + '0';
    }
    pbuf++;
  } while (value);
  *pbuf-- = 0;
  // String jetzt falsch herum vorn <-> hinten
  do {
    temp = *pbuf;
    *pbuf = *buf;
    *buf = temp;
    pbuf--;
    buf++;
  } while (buf < pbuf);
}


//
// konvertiert 16Bit Wert in String
//
void s16toa(signed short value, char *buf, unsigned char radix)
{
  if (value < 0) {
    *buf = '-';
    value = -value;
    buf++;
  }
  u16toa(value, buf, radix);
}

